/* 
 * crc_i.h
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993  Arizona Board of Regents
 *
 * $Revision: 1.1 $
 * $Date: 1994/06/09 00:32:43 $
 */

#ifndef crc_i_h
#define crc_i_h

typedef long 	CRChdr;
typedef long 	CRCtype;
typedef XObj  	PassiveId; 

typedef struct {
    Part     p[2];
    long     flags; /* &1 turns on IPpseudoheader length-fixup for session */
    long     LprefixL;       /* Length of any local prefix, in bytes */
unsigned char *Lprefix;      /* pointer to local prefix */
    long     RprefixL;       /* Length of any remote prefix, in bytes */
unsigned char *Rprefix;      /* pointer to remote prefix */
    /* Lprefix = Rprefix is ok, as long as LprefixL = RprefixL */
} SState;    /* session state */

typedef XObj ActiveId;

typedef struct {
    Map	     actMap;
    Map      pasMap;
    long     flags;  /* &1 turns on IPpseudoheader length-fixup for protocol */
} PState;    /* protocol state */



#define	CRC_ACTIVE_MAP_SZ	257
#define	CRC_PASSIVE_MAP_SZ	13

#endif
