/*
 * $RCSfile: codegen.h,v $
 *
 * Universal Stub Compiler
 *
 * Copyright (c) 1994    Arizona Board of Regents
 *
 * $Log: codegen.h,v $
 * Revision 1.1  1994/10/13 17:43:30  dorgival
 * Initial revision
 *
 */

#include "codegen_export.h"
#include "expr.h"
#include "usc_validate.h"
#include "icode.h"

typedef enum { IN_STRUCT, NOT_IN_STRUCT } AssignFlag;

typedef enum { SORT_LEFT, SORT_RIGHT } SortFlag;

typedef enum { ANY_TYPE, STANDARD_TYPE } ExprCheckFlag;

extern ICodeList *icode_list;
extern int     temp_var_count;
extern Symbol* Function;

extern int sym_cmp (Symbol **sym1, Symbol **sym2);

extern void icode_assign (Symbol *leftbase, 
                          Symbol *leftsym, Expr *leftoffset, 
			  Expr *real_leftoffset,
                          Symbol *rightbase, 
                          Symbol *rightsym,
                          Expr *rightoffset, 
			  Expr *real_rightoffset,
                          AssignFlag flag);

extern void icode_native_assign( char* var_name, Expr* expr );

extern void icode_struct_assign (Symbol *leftbase, Symbol *leftsym, 
                                 Expr *leftoffset, Expr *real_leftoffset,
                                 Symbol *rightbase, Symbol *rightsym,
                                 Expr *rightoffset, Expr *real_rightoffset);

extern void icode_struct_assign (Symbol *leftbase, Symbol *leftsym, 
                                 Expr *leftoffset, Expr *real_leftoffset,
                                 Symbol *rightbase, 
                                 Symbol *rightsym,
                                 Expr *rightoffset, Expr *real_rightoffset); 


extern void icode_union_assign (Symbol *leftbase, Symbol *leftsym, 
                                Expr *leftoffset, Expr *real_leftoffset,
                                Symbol *rightbase, Symbol *rightsym, 
                                Expr *rightoffset, Expr *real_rightoffset);

extern void gen_expr (Buffer *buf, Expr *expr, ExprCheckFlag exprcheck_flag);

extern void icode_basetype_assign (Symbol *leftbase, Symbol *leftsym,
                                   Expr *leftoffset, Expr *real_leftoffset,
                                   Symbol *rightbase, 
                                   Symbol *rightsym, Expr *rightoffset,
				   Expr *real_rightoffset);

extern void gen_sign_extend (Symbol *leftbase, Symbol *leftsym,
                             Expr *leftoffset, Expr *real_leftoffset,
			     char *leftoffsetvar,
                             Symbol *rightbase, Symbol *rightsym, 
                             Expr *rightoffset, Expr *real_rightoffset,
                             char *rightoffsetvar, 
                             ByteOrder leftendian, ByteOrder rightendian);

extern void do_sign_temps (void);
extern int compatible_struct_fields (Symbol *left, Symbol *right);
extern void optimize_icode(void);
extern void set_max_key (void);
extern void add_param_name (char *name);
extern void add_param (int n, Symbol *sym, ParamFlag flag, ...);
extern void push_code_level (void);
extern void pop_code_level (void);
extern int standard_type (Type *thetype);
extern int byte_pos (int byte, char *order, int memsize);
extern char *add_strings (char *left, char *right);
extern int compatible_arrays (Symbol *leftsym, Symbol *rightsym, int *total_el,
                              Type **leftspec, Type **rightspec);
extern char *print_offset (char *var);
extern int num_set_bits (unsigned long value);
extern int which_bit_set (unsigned long value);



#define icode_key(a,b)      ((b) == SORT_LEFT ? (a)->left.key : (a)->right.key)
#define round_down_byte(a)  ((a) & ~7)
#define round_up_byte(a)    (((a) & 7) ? (((a) & ~7) + 8) : (a))
#define aligns_match(a,b) ((a) % (b) == (0))

