/*
 * $RCSfile: usc.h,v $
 *
 * Universal Stub Compiler
 *
 * Copyright (c) 1994    Arizona Board of Regents
 *
 * $Log: usc.h,v $
 * Revision 1.1  1994/10/13 17:43:30  dorgival
 * Initial revision
 *
 *
 */

/*
 * General include files and useful definitions for usc and usit
 */

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#ifdef USE_DMALLOC
#include <dmalloc.h>
#endif
#include <string.h>
#include <limits.h>
#include <time.h>

#ifndef ASSERT
#define NDEBUG
#endif
#include <assert.h>

#include "hash.h"
#include "mem.h"
#include "symbol_defs.h"
#include "config.h"
#include "expr_defs.h"
#include "debug.h"
#include "prototypes.h"

#ifndef DEBUGLEVEL
#define DEBUGLEVEL 10
#endif

#ifndef TRIGGER_COREDUMP
#define TRIGGER_COREDUMP 0
#endif


typedef enum {
  GEN_PLAIN = 0x01, GEN_INLINE = 0x02, GEN_MACROS = 0x04, GEN_STATIC = 0x08
} CodeType;

#define CODE_IS_MACRO     (code_type & GEN_MACROS)
#define CODE_IS_INLINE    (code_type & GEN_INLINE)
#define CODE_IS_PLAIN     (code_type & GEN_PLAIN)
#define CODE_TYPE_SET     (code_type & (GEN_INLINE|GEN_MACROS))
#define CODE_IS_STATIC    (code_type & GEN_STATIC)


extern CodeType DefaultCodeType;

extern int Debug_Level;
extern int LineNum;
extern FILE *OutFile, *HeaderFile;
extern char *InFileName;
extern char *HeaderFileName;
extern int gen_opt_code;
extern int total_malloced;
extern int print_comments;
extern int do_preprocess;
extern int preserve_type_names;
extern int make_validate;
extern int speed_test;
extern CodeType code_type;
extern Hash_Tab *Type_Tab, *Symbol_Tab, *Struct_Defs, *Union_Defs;

extern void inityy(void);
extern void crash (char *fmt, ...);
extern void error (char *fmt, ...);
extern void warning (char *fmt, ...);
extern char *allocate_new_string (char *string);
extern char *allocate_temp_string (char *string);
extern int yyparse (void);
extern int strmem (char *string);
extern int lcm (int x, int y);
extern int gcd (int x, int y);

#define dexec(level,func) { if ((level) <= Debug_Level) func; }
#ifndef MAX
#define MAX(a,b)  ((a) >= (b) ? (a) : (b))
#define MIN(a,b)  ((a) <= (b) ? (a) : (b))
#endif

#ifndef ABS
#define ABS(a)    ((a) >= 0 ? (a) : -(a))
#endif


#define LEFT  0
#define RIGHT 1

